\section{Experiments}
\label{sec:experiments}

We evaluate GRT by investigating the following questions:
\begin{enumerate}[label=Q\arabic*:]
\item How much do the code coverage and mutation score improve compared with Randoop and EvoSuite?\label{it:q-cov}
\item How much does each component improve code coverage?\label{it:q-cov-each}
\item Does code coverage reach a saturation point more quickly or slowly when the components of GRT function?\label{it:q-sat}
\item How many defects can be found in real software by GRT?\label{it:q-bugs}
\item How many false positives are caused by GRT?\label{it:q-fp}
\end{enumerate}

\subsection{Subject Programs and Setting}

\begin{table*}
\caption{Benchmarks: Size and complexity metrics, and test results.
}
\begin{center}
\resizebox{\linewidth}{!}%
{\scriptsize
\setlength\tabcolsep{3pt}
\input{benchmarkDescription-table.tex}
}
\end{center}
\label{table:benchmarks}
\end{table*}

We compare GRT with Randoop\,1.3.4\,\cite{Toolkit:Randoop}, and to a
snapshot of EvoSuite from July 24, 2014\,\cite{Toolkit:Evosuite}.
%\footnote{
%Although it would also be interesting to compare with ART tools, only Constant mining of GRT is
%related to ART, while other components are orthogonal to ART techniques. 
%To the best of our knowledge, there are currently no publicly available tools~(in Java) that support
%to work on the large collection benchmarks we used, forcing us to leave the study of ART
%as an alternative of constant mining and its effectiveness as an component of GRT as future work.
%}
%(released in January 2014)% ~\cite{Pacheco:2005:EAG:2144892.2144921}
%We use Randoop with default settings, unless indicated otherwise.
%Each component of our GRT can be activated separately, allowing us to evaluate them individually.
We select Evosuite because
it is a state of the art automated testing tool integrating advanced
techniques like
search-based testing and dynamic symbolic execution~\cite{6698889,Fraser:2013:WTS:2478542.2478706}.
%, which has been shown effective in achieving high code coverage in practice~\cite{Fraser:2013:WTS:2478542.2478706}.
It would be interesting to include adaptive random testing
(ART) tools in our analysis as well, as our constant mining technique
is related to it.
Unfortunately, to the best of our knowledge, there are currently no
publicly available ART tools that support Java and
work on the large set of benchmarks we used,
forcing us to leave such a comparison as future work.
% and its usefulness as a component of GRT as future work.
%Although Evosuite is not based on FRT, we selected 
%it for comparison, because it is a state of the art automated testing tool integrated advanced techniques in
%search-based testing and dynamic symbolic execution~\cite{6698889,Fraser:2013:WTS:2478542.2478706}.
%Although it would be interesting to compare with ART tools, only our Constant mining is
%related to ART while other components of GRT are orthogonal techniques to ART. 
%To the best of our knowledge, there are currently no publicly available ART tools~(in Java) that support
%to work on the large set of benchmarks we used, forcing us to leave the study of ART
%as an alternative of Constant mining and its usefulness as a component of GRT as future work.

%Fraser:2011:EAT:2025113.2025179
%that performs whole test suite generation.

We used a collection of 30 popular real-world programs as the subjects of our experiment. 
The overview in Table~\ref{table:benchmarks} shows for each package its name, program version, 
the number of classes it contains, its overall size in terms of non-comment lines of source code 
(NCLOC)~(measured by CLOC 1.60~\cite{Toolkit:CLOC}), 
%\footnote{Using CLOC 1.60, \url{http://cloc.sourceforge.net/}.}
and the number of instructions and branches in the bytecode~(measured by JaCoCo v0.6.4~\cite{Jacoco:2013}),
plus the number of mutants generated by the tool PIT~\cite{Toolkit:PIT} to measure
the bug finding ability of the generated tests.
The remaining columns show the results of our experiments.
To save space, we put all additional experimental results and data plot online~\cite{Toolkit:GRT}.
%\url{https://sites.google.com/site/grtprojectut/icse15/}.


All experiments were run on a GNU/Linux system (Ubuntu 12.04 LTS)
running Linux kernel 3.5.0 on a 16-core 1.4\,GHz AMD 64-bit CPU with
48\,GB of RAM, with Oracle's Java VM (JVM) version 1.7.0\_65, using
up to 4\,GB for the JVM.

\subsection{Code Coverage and Mutation Score}

\ref{it:q-cov} %
We compare the effectiveness of each tool in terms of 
code coverage and mutation score on the subject programs.
Each tool is given 3000 seconds as time budget for test 
generation~(excluding the time of pre-processing and post-processing, 
such as loading classes and writing test cases to disk).
All the generated tests are evaluated by JaCoCo for code coverage.
As a conventional procedure of mutation analysis~\cite{Jia:2011:ASD:2052439.2052494},
we first filter out generated test cases that fail on the original programs, 
and then execute remaining test cases on mutants generated by PIT to compute
mutation scores.

%Coverage data in terms of instruction,
%branch, and mutation score are summarized in
%Table~\ref{table:benchmarks} for all packages, where
%each tool is given 3000 seconds as time 
%budge for test generation~(without including the overhead in pre-processing and post-processing
%time of each tool such as class loading, test case writing to disk).
%All the generated JUnit tests by each tool is then run by JaCoCo to evaluated code coverage. 
%For mutation score analysis of the generated tests, we filter out all the failed tests of each tool, 
%and only run the \emph{green\ tests}~(the passed tests) by the tool PIT for bug detection evaluation
%of the tests.

%each configuration runs with 3000 seconds as time limit.

Table~\ref{table:benchmarks} summarizes the experimental results.\footnote{
PIT does not support Javassit. Evosuite fails to generate tests for Javaxmail.}
We can see that GRT improves the average code coverage by about 10\,\%
over Randoop and about 6\,\% over EvoSuite. The code coverage of GRT, 
however, is not a strict superset of EvoSuite's code coverage,
which shows that there is still room for improvement for both tools~(refer to~\cite{Toolkit:GRT}).
Besides code coverage, GRT also improves average mutation score by about 10\,\%
over Randoop and about 9\,\% over EvoSuite, showing that the tests generated by GRT
have better performance in revealing automatically seeded faults (i.\,e., mutations).
We have also conducted the experiment with a time budget of 600 seconds. 
The results are similar to those shown in Table~\ref{table:benchmarks}, where GRT outperforms 
Randoop and Evosuite in terms of both code coverage and mutation score. Due to space limitation,
the data are omitted here and put on our website~\cite{Toolkit:GRT}.

Figure~\ref{fig:total-cov} shows the overall results as a box plot. 
The plot depicts the data as quartiles: The box area contains
the spread of 50\,\% of all results;
the horizontal line inside the box indicates the median;
the whiskers at the top and bottom show the extreme cases. 
GRT shows an obvious improvement on both code coverage, and mutation score 
on the studied benchmarks compared with Randoop and 
Evosuite~(also see Table~\ref{table:benchmarks} for $\mu$, $\sigma$).
Furthermore, such improvement of GRT is also significant~(at $p <
0.05$ significance level) as confirmed by the Wilcoxon Matched-Pairs
Signed-Ranks Test~\cite{Sheskin:2007:HPN:1529939}.
% see Table~\ref{table:benchmarks} for $\mu$, $\sigma$
%with the $\mu$ value of GRT for each comparison item significantly larger than the other tool 
%at $p\leq 0.05$ (by Wilcoxon Matched-Pairs Signed-Ranks Test~\cite{Sheskin:2007:HPN:1529939}))

Although the time budget of test generation is fixed for each tool, 
their real execution time may differ from the given value due to the overhead of running each 
tool~(measured by GNU Time~\cite{Toolkit:Gnutime}).
%~(we measure the real run-time of each tool by GNU Time~\cite{Toolkit:Gnutime}).
On the subject programs, Randoop always sticks to the given time budget with an overhead up to 50 seconds.
Compared with Randoop, GRT has a minor additional overhead in the static phase (up to 100\,s),
and otherwise also adheres to the global time budget.
EvoSuite, on the other hand, has no mechanism to control its overall run time accurately, 
and the only way of run time control is setting a time limit for the evolutionary 
test generation phase. Therefore, for Evosuite, we give each class 
the time budget $|\mathit{global\ time\ budget / number\ of\ testable\ classes}|$.
%that applies to all classes uniformly.
%We summarize the ratio of real execution time over given time budget for Evosuite in the last column of Table~\ref{table:benchmarks}.
%and allows no fractional values.
The phase where the time limit applies may not be the 
cost-dominant phase of the entire tool.
EvoSuite may therefore use as much as 11.6 times the budgeted amount of time,
or use $\frac{3}{10}$ of the allocated time
on some subjects where a desired coverage level was reached earlier
(which causes EvoSuite to stop the search). The relative deviation~(the ratio) of
EvoSuite's run time compared with the global time budget is shown in the
last column of Table~\ref{table:benchmarks}.


\ref{it:q-cov-each} In general, each individual component of GRT
shows some improvement; the impact of each component varies across different cases.
The combination of all six components is usually much stronger than a single component, 
which can be seen from the overall branch coverage over 30 subjects
(see Fig.~\ref{fig:cov-per-enh}).
To save space, we put the detailed coverage plots online~\cite{Toolkit:GRT}.

%although it would also be interesting to evaluate the mutation score for each enhancement,
%We did not compute mutation score for each individual component, because of the prohibitively
%high cost of so many iterations of mutation analysis. 
Fig.~\ref{fig:guava} shows a representative example, where each component shows improvement.
%each enhancement shows improvement on a some benchmark like Guava~(see Fig.\ref{fig:guava}).
Constant mining is quite effective in improving code coverage when
some of the extracted constants are relative to branch conditions. %~(see Fig.~\ref{fig:tinysql}).
There are also cases where only the detective makes a code coverage breakthrough by 
automatically constructing objects of specific types~(e.\,g. Apache compress~\cite{Toolkit:GRT}).
%that cannot be generated only by the target MUTs.
However, in some cases, certain components of GRT may worsen performance (see Fig.~\ref{fig:scch-timel}).
We believe that automatic fine-tuning the parameters of the components
can counteract this and we will investigate this in our future work.

\def\plotscale{0.7}% how much to scale the plots
\def\timelinescale{\plotscale}% how much to scale the plots
\def\negspace{0.7}% how much space to remove;
% as only the legend is at the bottom of the plot, it's mostly whitespace
\def\topspace{0.2}% how much space to add at the top

% from repo ase-2014-coverage on bitbucket
\begin{figure}[tb]
\centering
\includegraphics[scale=\plotscale]{cov_pdf/total_cov_3000s}
\caption{Instruction and branch coverage, and mutation score of Randoop, GRT and Evosuite (3000\,s as the testing budget).}\label{fig:total-cov}
\end{figure}

\begin{figure}[tb]
\vspace{\topspace\baselineskip}
\centering

\includegraphics[scale=\plotscale]{cov_pdf/total_bcov_600s}
\vspace{-.5\baselineskip}% less neg. vspace as bottom part has little whitespace
\caption{Branch coverage for each component (600\,s).}\label{fig:cov-per-enh}
\end{figure}


%\begin{figure*}[!htb]
%\vspace{\topspace\baselineskip}
%\minipage{0.45\textwidth}
%  \includegraphics[width=\linewidth]{cov_pdf/total_cov_3000s}
%  %\vspace{-\negspace\baselineskip}
%\caption{Instruction and branch coverage, and mutation score of Randoop, GRT and Evosuite (3000\,s as the testing budget).}\label{fig:total-cov}
%   \endminipage\hfill
%\minipage{0.45\textwidth}
%  \includegraphics[width=\linewidth]{cov_pdf/total_bcov_600s}
%\caption{Branch coverage for each component (600\,s).}\label{fig:cov-per-enh}
%\endminipage\hfill
%%\minipage{0.33\textwidth}%
%%  \includegraphics[width=\linewidth]{cov_pdf/scch_timel_b}
%%  \caption{Branch coverage timeline~(SCCH collections).}\label{fig:scch-timel}
%%\endminipage
%\end{figure*}


\ref{it:q-sat} GRT provides much faster coverage saturation
but still allows for some incremental improvements when Randoop
already tapers off (see
Fig.~\ref{fig:guava}--\ref{fig:scch-timel}).
%Usually the Orienteering enhancement is effective by itself, 
Beyond that, there are also cases where some component makes
a big difference, including in plots shown online~\cite{Toolkit:GRT}.
While Randoop and GRT analyze all classes together,
EvoSuite handles classes one by one and 
does not support coverage timeline plot in its latest snapshot, forcing us
to exclude such analysis for Evosuite.
%Although it would also be interesting to study the timeline coverage behavior of Evosuite, 
%forcing us unable to observe its such coverage behavior by time.
% therefore (+++Update is this really the case?) not
%applicable for EvoSuite.

%\begin{figure*}[tb]
%\centering
%\begin{tabular}{c c}
%\includegraphics[scale=\plotscale]{cov_pdf/total_scov_600s}
%&
%\includegraphics[scale=\plotscale]{cov_pdf/total_bcov_600s}
%\end{tabular}
%\vspace{-.5\baselineskip}% less neg. vspace as bottom part has little whitespace
%\caption{Instruction and branch coverage for each enhancement (after 600\,s).}\label{fig:cov-per-enh}
%\end{figure*}




%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=\timelinescale]{cov_pdf/Guava_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (Guava).}\label{fig:guava}
%\end{figure}



%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=\timelinescale]{cov_pdf/TinySql_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (Tiny sql).}\label{fig:tinysql}
%\end{figure}

%\begin{figure*}
%\centering
%\begin{minipage}{.4\textwidth}
%  \centering
%  \includegraphics[scale=\timelinescale]{cov_pdf/TinySql_timel_b}
%  \captionof{figure}{A figure}
%  \label{fig:test1}
%\end{minipage}%
%\begin{minipage}{.3\textwidth}
%  \centering
%  \includegraphics[scale=\timelinescale]{cov_pdf/TinySql_timel_b}
%  \captionof{figure}{Another figure}
%  \label{fig:test2}
%\end{minipage}
%\end{figure*}



%\begin{figure*}[tb]
%\centering
%\begin{tabular}{c c}
%\includegraphics[scale=\plotscale]{cov_pdf/Guava_timel_b}
%&
%\includegraphics[scale=\plotscale]{cov_pdf/total_bcov_600s}
%\end{tabular}
%\vspace{-.5\baselineskip}% less neg. vspace as bottom part has little whitespace
%\caption{Instruction and branch coverage for each enhancement (after 600\,s).}\label{fig:cov-per-enh}
%\end{figure*}



%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=\timelinescale]{cov_pdf/joda_time_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (Joda time).}\label{fig:jodatime}
%\end{figure}


%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=\timelinescale]{cov_pdf/apache_comp_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (Apache commons compress).}\label{fig:apache-comp-timel}
%\end{figure}

%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=\timelinescale]{cov_pdf/apache_coll_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (Apache commons collections).}\label{fig:apache-coll-timel}
%\end{figure}

\begin{figure*}[!htb]
\vspace{\topspace\baselineskip}
\minipage{0.31\textwidth}
  \includegraphics[width=\linewidth]{cov_pdf/Guava_timel_b}
  %\vspace{-\negspace\baselineskip}
  \caption{Branch coverage over time (Guava).}\label{fig:guava}
   \endminipage\hfill
\minipage{0.31\textwidth}
  \includegraphics[width=\linewidth]{cov_pdf/TinySql_timel_b}
\caption{Branch coverage over time (Tiny sql).}\label{fig:tinysql}
\endminipage\hfill
\minipage{0.31\textwidth}%
  \includegraphics[width=\linewidth]{cov_pdf/scch_timel_b}
  \caption{Branch coverage by time~(SCCH collections).}\label{fig:scch-timel}
\endminipage
\end{figure*}

%  \includegraphics[width=\linewidth]{cov_pdf/apache_comp_timel_b}
%  \caption{Branch coverage over time (Compress).}\label{fig:apache-comp-timel}

%\begin{figure}[tb]
%\vspace{\topspace\baselineskip}
%\centering
%\includegraphics[scale=.5]{cov_pdf/scch_timel_b}
%\vspace{-\negspace\baselineskip}
%\caption{Branch coverage over time (SCCH collections).}\label{fig:scch-timel}
%\end{figure}


\subsection{Defect Detection}
\ref{it:q-bugs} We evaluated the ability of defect detection 
of each tool first on the SCCH classes, which are well designed~\cite{ramler2012}, 
and then on the real-world open-source projects, where the problem 
is more open and valuable in practice.

\subsubsection{SCCH Collection}
The SCCH collection package is based on a reimplementation of 
common Java collection classes (such as list, array, set, stack, and map) 
for teaching purposes. It has been used in our previous experiments 
on test case generation~\cite{ramler2012}, where we 
manually seeded 37 defects. We first chose this package to investigate 
defect detection.
% is affected by the different enhancements.

The behavior of collection classes is heavily influenced by their 
internal state in terms of the number of elements they contain. 
%Since the elements are only stored and not processed, their value is 
%usually not of importance unless it is \texttt{null} or the collections are ordered.
Thus, %for this type of software, 
operations that mutate the object state help to increase the 
coverage and to trigger failure cases.
Consequently, as one can see 
in Fig.~\ref{fig:scch-timel}, the \emph{Impurity} component improves coverage 
results. 
\emph{Bloodhound} favors to select methods with low code coverage and also helps to improve coverage.
%where many of the favored methods are also the ones that mutate the object states.
\emph{Orienteering} does even better in this case because some 
operations that mutate the state are also fast and thus frequently 
used by this heuristic, where 49.5\%~(94 out of 186) of MUTs in SCCH collection are impure methods.

However, the SCCH collections do not contain many extracted constants~(with 16 in total).
It has a small number of classes, and its MUTs also have few input type dependencies on packages 
other than itself.
%The number of classes is also relatively small with low type dependency and little dependency
%of types other than CUTs themselves.
This makes \emph{Constant\ mining}, \emph{Elephant brain}, and
\emph{Detective} less helpful in improving the coverage when being used separately.


%Constant mining provides elements of different 
%types, which increases the coverage in cases where elements are compared. 
%%% +++ UPDATE: does this still hold?
%In contrast, the Bloodhound tends to favor diverse sequences, 
%which limits the chance for state changes. Selecting methods based 
%on the coverage works poorly in case of collection classes. While the two-phase 
%approach of Bloodhound mitigates this problem to a large extent, it does not 
%produce a coverage improvement in this case.


%\begin{figure}
%\centering
%\includegraphics[scale=.68]{heatmap/heatmap}
%\caption{Behavior of our enhancements on the SCCH collection classes,
%with \texttt{null} values enabled.}\label{fig:scch-heatmap}
%\end{figure}

\begin{table}
\caption{Defects found in the SCCH collection classes.\label{table:scch-bugs}}
\begin{center}
\scriptsize
\begin{tabular}{|l|r|r|r|}
\hline
& Randoop & GRT & EvoSuite\\
\hline
\hline
Defects found & 13 & 17 & 29 \\
\hline
Unique defects found & 0 & \textbf{3} & \textbf{14} \\
\hline
\end{tabular}
\end{center}
\end{table}


In line with our previous case studies~\cite{ramler2012},
we analyze the defect detection ability of the tests generated by each tool, 
using the same run-time configuration as shown in Table~\ref{table:benchmarks}, 
where each tool is given 3000 seconds as testing time budget.
Then, the generated tests are used to measure the number of bugs each tool 
detects.
%Different from the mutation analysis, the bug detection analysis 
%we also run all the enhancements in varying configurations 
%and including the option of using \texttt{null} as input value at a probability
%of 10\,\%.
The total number of defects found, as well as the
number of defects only found by each individual tool, are shown in Table~\ref{table:scch-bugs}.
% The results are summarized in Fig.~\ref{fig:scch-heatmap}. 
%They show that the enhancements can have a mixed, positive 
%and negative effect. Furthermore, using \texttt{null} values also 
%has a major impact on how our enhancements
%interact. Although we get a similar overall improvement, the Impurity
%enhancement is much less useful in combination with \texttt{null} inputs
%than under default settings (see Fig.~\ref{fig:scch-timel}).
We can see that GRT detects \textbf{4} more bugs than Randoop and finds \textbf{3} unique defects that
cannot be detected by either Randoop or Evosuite.

In the case of the SCCH collections, Evosuite exhibits
higher code coverage and mutation score than GRT and Randoop~(see Table~\ref{table:benchmarks}).
It also finds more defects than GRT.
Besides the coverage advantage of Evosuite on this benchmark, our further analysis on the 14 
unique bugs found by Evosuite shows that although GRT covers the code for \textbf{10} of them~(the other 4
are undetected because their code is not covered), GRT lacks suitable oracles to reveal these bugs.
% although GRT and Randoop also covers the code of these bugs, they 
%lacks a strong oracle to detect these bugs.
%Among the 14 unique bugs found by Evosuite, GRT covers the code for 10 of them
This is to a large extent because container classes represent a case where MUTs have many algorithmic properties, 
e.\,g., symmetric operators like \texttt{compare}, lending themselves to the test oracles generated by EvoSuite.
Randoop and GRT, on the other hand, focus on a few predefined simple oracles and the observation
of system crashes.%, which greatly limits their defect detection capabilities.%
\footnote{These built-in oracles cover behaviors stipulated for
base class \texttt{java.lang.Object}~\cite{Pacheco:2007:RFR:1297846.1297902}
such as an object must be equal to itself.} % with $o.equals(o)$ returns 
%true, which applies to all subclasses as well.}
However, the oracle generation is orthogonal to our proposed components of GRT.
We think similar oracle generation techniques of Evosuite could also be adapted to GRT to further improve
its bug detection ability. We leave the oracle enhancement in GRT as future work.

%The analysis of SCCH container classes also suggests that the
%quality of the test oracle also can improve defect detection; enhancing
%test oracles in GRT is another important future work.


\subsubsection{Open Source software}

For a more in-depth evaluation of bug detection improvement,
we apply GRT to the most recent version of
real-world popular software projects, with the goal of uncovering new, previously
unknown defects.

To have enough time to evaluate the reports and to confirm bugs, this part of the study
was performed on a slightly older version of our GRT tool with parameters of some components 
not yet tuned. As the generated failed tests from each tool require manual analysis to confirm whether
they uncover a \emph{true} bug or generate a false positive, 
we chose 10 projects among 30 studied projects
to make our study feasible,
where the selected projects are still under active development (the last update being less than
a year ago), and the number of failed test cases reported is not
prohibitively high (i.\,e, fewer than 100 failed tests); see
Table~\ref{table:bugs-found}.

%That version
%provides the same enhancements but has somewhat lower coverage because
%the parameters of some enhancements were not yet tuned.
%As the bug detection analysis of each tool

%This selection results in ten projects (see Table~\ref{table:bugs-found}).
The initial number of test cases to be considered by both tools is still very high,
with a total number of over 200 tests.
To limit the manual evaluation effort, we first filter out tests that
confirm a problem that is either known
or not going to be fixed in the code, such as bugs caused by using
deprecated methods, non-public methods, and infinite recursion in container
data structures.

%These issues include:

%\begin{itemize}
%\item \textbf{Deprecated methods.} Methods may be marked as \emph{deprecated}
%if they contain or expose a design flaw.
%A deprecated method may allow incomplete
%objects to be used before all invariants are established. Such methods are
%usually removed from the library in the future.
%\\
%In our context, tests involving such code confirm previously known issues.
%These are usually true positives but as the code may be
%removed soon, the defects may not be fixed anymore.
%Ignoring these issues allowed us to focus on unknown flaws.
%\item \textbf{Stack overflows.} Container classes, such as found in the
%Apache collection library or Guava, allow recursive nesting of data.
%For example, a list $l_1$ can be inserted into another list $l_2$,
%followed by an insertion of $l_2$ into $l_1$. Operations such as list
%iteration or \texttt{toString} will then never terminate on the resulting
%objects.%
%\footnote{%
%It is possible to make iteration robust against infinite recursion,
%but a fix entails keeping track of previously visited object
%instances during iteration. This requires an amount of memory
%that is linear in the size of the collection; the cure would be worse
%than the disease in most cases.}
%\item \textbf{Internal packages.} Such packages occur in project
%\texttt{javax.mail} and usually start with \texttt{com.sun}. They 
%are specific to the given reference implementation and not meant to be used by
%others. Possibly unsafe API uses found by test cases are therefore
%irrelevant.
%\end{itemize}

\begin{table}
\caption{Defect detection capability of GRT: GRT finds 21 previously unknown defects. The last row shows Randoop for comparison.}

\begin{center}
\resizebox{\linewidth}{!}%
{\scriptsize
\setlength\tabcolsep{3pt}
\input{bug-table.tex}
}
\end{center}
\label{table:bugs-found}
\end{table}

This filtering reduces the number of failed test cases 
to 151 tests (see Table~\ref{table:bugs-found}).
We manually simplify the remaining tests. Often it
becomes apparent that a given test is a variation of an earlier
one. This can be confirmed by comparing their stack traces and
the sequences of method calls. 
%Test minimization also may
%confirm if two failing tests are exposing the same issue.

As this phase is still difficult and time consuming,
we limit our analysis of failed tests in \emph{Apache math} to
the first 20 tests found by each tool.
We classify these failed tests into distinct \emph{issues}.
When doing so, we count the same
defect in two classes as two issues, as well as two different
types of problems in the same class. This results in 50
issues, which are then
investigated more closely. Based on the API documentation and
our own experience, we discount some as false positives.

Remaining open issues were reported to the issue tracker of each project. 
To limit the number of reports, we created only one issue ticket
for similar defects across a given class or multiple classes.
Based on feedback from
developers, we classify the originally counted issues as false or
true reports. Unconfirmed cases are counted as unknown.
Finally, we show the total numbers for GRT and, for comparison,
the totals for Randoop (see Table~\ref{table:bugs-found});
detailed numbers for Randoop are elided due to space constraints.

We are happy that our work resulted in \textbf{21} previously unknown bugs being
confirmed.
Most of our reported defects have already been fixed in the development version of given projects.
%Most of these  are already fixed in the development version of the
%given projects. Seven confirmed defects 
%can be attributed to our enhancements of Randoop and
%were not found by the original tool. 

\ref{it:q-fp} We also repeated the bug-finding experiments with 
Randoop, which finds 115 failing tests resulting in 31 selected issues
using the approach outlined above. Randoop misses seven issues
that GRT finds, while all the bugs it finds are also detected by GRT.
The false-positive rate of Randoop is very similar to ours.

%The analysis of SCCH container classes also suggests that the
%quality of the test oracle also can improve defect detection; enhancing
%test oracles in GRT is another important future work.

\subsection{Summary}

GRT significantly improves code coverage and mutation score when
all components are used together.
Not all components of GRT are equally effective in all cases.
%and we expect that more fine-tuning will improve results.
GRT usually improves the rate at which code
is covered, and contributes to finding more defects than Randoop.
The false-positive rate is not adversely affected by GRT, but the quality of the test oracle 
still has room for improvement.


\subsection{Threats to Validity}
The benchmark selection itself is always a threat to validity. We
try to counter this by choosing 30 diverse programs in various application
domains with their sizes ranging from very small to fairly large.

The internal overhead of running each tool is another threat to validity.
The overhead of GRT is less than 150 seconds on all studied subjects
%~(up to additional 100 seconds on the static phase compared with Randoop)
and therefore not significant compared with the total 
run time~(3000\,s). 
The overhead of EvoSuite varies among different projects, and it sometimes
dominates the whole test case generation~(see the last column of
Table~\ref{table:benchmarks}).
Allowing EvoSuite to use on average {2.2} times the desired test generation time budget 
(up to 11.6 times more time in some cases) favors it, although it occasionally finishes early. 
%(+++UPdate additional threats? run configuration )

Another external threat to validity is caused by the randomness of the three tools.
Considering the fairness of comparison, we fix and use the same random seed for each 
tool. To diminish this threat, we could run each tool multiple times.
Due to time constraints, we chose a large time limit (3000\,s) instead,
which allows the tools to reach a relatively stable level of coverage.
In addition to that, some components of GRT depend
on time intervals.
This can produce slight deviations across multiple executions.
However, the overall coverage results vary only by about 2\,\% across different
random seeds and executions when all components
are used together, as their internal variations tend to cancel each
other out.
